{
  name:          DOORLIB VERSION 2.1
  date:          27/05/1997
  author:        iCode
                  EsdimaX / Vic Boone / fALCON
  func:          serial port fossil library
  dist:          iCode internal use only !!!
}

{$M 32768, 0, 650000 }

unit doorLib;

interface
  {$I struct.200 }

type
     fchar = record
               case word of
                 0 : (w : word);
                 1 : (chr : char; src : (server,client));
               end;
     byteArray = array[0..$FFFE] of byte;
     bytePtr   = ^byteArray;
     state = record
               showMessage : boolean;   { Nachricht mu noch gezeigt werden }
               MessageDone : boolean;   { Nachricht wird nie wieder gezeigt }
               kill        : boolean;   { DOORLIB mu sofort beenden ! }
     end;

const
  ver        = '2.10';
  ver_high   = 2;
  ver_low    = 10;
  local      : boolean = true;          { gesetzt, wenn kein ONLINE Verbindung }
  debug      : boolean = true;          { gesetzt, wenn EXITINFO.BBS vorhanden }
  timeover   : boolean = false;         { Ende des tglichen Zeit-Limits ! }
  timeout    : boolean = false;         { Flag, um ein Timeout zu signalisieren }
  modemHanged: boolean = false;
  message    : array[1..2] of string = ('   PlEASE PRESS ANY kEY T0 dEACTiVATe iNACTiViTY-C0UNTD0WN!!! - 1 MiNUTE lEFT   ',
                                        '                  DAilY TiME LiMiT REACHED!!! - 1 MiNUTE lEFT                   ');

var
  dailyTime   : word;                   { Tgliche Zeit insgesamt in Minuten }
  restTime    : word;                   { Restzeit in Minuten }
  einfof      : file;
  ansierror   : byte;                   { ungleich 0, wenn Fehler auftreten }
  exitinfo    : ExitInfoRecord;

procedure initDoorLib(nodePath : string);

procedure ansi (s : string);
procedure fwrite (s:string);
procedure fwriteln (s:string);
procedure fwritechar (c:char);


function  freadkey : word;
function  fkeypressed : boolean;

procedure fgotoxy (x,y:byte);
Procedure cursorOff;

procedure ftextcolor(c:byte);
procedure ftextbackground(c:byte);
function  writeColour(c, b : byte):string;

procedure setWatchDog ( on : boolean );
procedure hangup( hbyte , hbit : byte ); { Hangup-Bits setzen, Hinweisbildchen anzeigen... }
procedure fBox ( s1 , s2 , s3 : string);
function  freset ( fileName : string ; var fileHandle : file ) : boolean;

function  pushScreen( x1 , y1 , x2 , y2 : byte) : bytePtr;
procedure popScreen( p : bytePtr );


implementation

uses dos, crt;

{$I ANSI.INC}

const
  _activity  = 1092*5;                  { 5  Minuten bis Reset (nach 4 TimeOut) }
  error      : boolean = false;
  messageBuf : bytePtr = nil;           { Pointer auf Bytearray mit gesicherten
                                          Daten der ersten Bildschirmzeile.
                                          Wenn pointer = nil, keine Daten
                                          gesichert... }
  restTime18  : word = 0;                 { zhlt die (1/18,2) sec fr Resttime }


var
  extchar     : char;                   { erweiterter Tastaturcode, wenn fchar.chr=#0 }
  fossilport  : byte;                   { Der Name sagts doch wohl }
  nodeDir     : string;                 { Das Node-Verzeichnis }
  raDir       : string;                 { Das RA-Verzeichnis }
  buf         : array[0..8191] of byte;
  oldexitproc : pointer;
  ansis       : byte;
  oldint8     : pointer;
  activity    : word;                   { Counter, zhlt 5 Minuten runter }
  hangCounter : word;                   { Counter, zhlt 1 Minute runter }
  daily       : state;
  inactivity  : state;
  carrier     : state;

procedure drawMessage( n : byte );
begin
  messageBuf := pushScreen( 1 , 1 , 80 , 1 );
  fgotoxy(1,1);
  fwrite( writeColour(14,4) + message[n]);
  cursorOff;
end;

procedure checkMessageStates;
begin
  if inactivity.showmessage then begin
     drawMessage(1);
     inactivity.showmessage:=false;
  end;
  if inactivity.kill then begin
    hangup(0,0);
    halt;
  end;
  if daily.showMessage then begin
     drawMessage(2);
     daily.showMessage := false;
  end;
  if daily.kill then begin
    hangup(0,0);
    halt;
  end;
  if carrier.kill then begin
    hangup(0,0);
    halt;
  end;
end;

procedure ansi (s : string);            { gibt eine ANSI-Datei aus }
label raus;
var f  : file;
    nr : word;
begin
  ansierror:=1;
  assign(f,s);
  {$I-} reset(f,1); {$i+}
  if ioResult <> 0 then exit;

  repeat
    nr := filesize( f ) - filepos( f );
    if nr > sizeof(buf) then nr := sizeof(buf);
    if nr<>0 then
    begin
      {$i-} blockread( f , buf , nr ); {$i+}
      asm
        mov  si, offset buf
        mov  cx, nr
      @localOutput:
        lodsb
        push si
        push cx
        push ax
        call ansiWrite
        pop  cx
        pop  si
        dec  cx
        jnz @localOutput

        cmp local, 0
        jne @noSerialOutput

        mov  ax, ds
        mov  es, ax
        mov  di, offset buf
        xor  dh, dh
        mov  dl, fossilport
        mov  cx, nr
      @serialOutput:
        mov  ah, 19h
        int  14h
        add  di, ax
        sub  cx, ax

        mov  ah, 3
        int  14h
        test al,128
        jne  @ok
        mov  modemhanged, 1
        jmp  raus
      @ok:
        cmp  timeout,0
        jne  raus                      { wenn TimeOut detect }

        or   cx, cx
        jnz  @serialOutput

      @noSerialOutput:
      end;
    end;
  until nr<sizeof(buf);
  raus:                                 { hierhin springen, wenn timeout }

  {$i-} close(f); {$i+}
  ansierror:=0;

  checkMessageStates;
end;

procedure popScreen( p : bytePtr );
var
  oldCol      : byte;
  buf         : string;
  n           : byte;
  x, y, i     : word;
  x1,y1,x2,y2 : byte;
begin
  if p = nil then exit;
  x1 := p^[0]; y1 := p^[1];
  x2 := p^[2]; y2 := p^[3];
  oldCol := p^[5];
  buf    := writeColour (oldCol and 15, oldcol shr 4);
  fwrite( buf );
  i := 4;
  for y := y1-1 to y2-1 do
  begin
    fGotoXy( x1 , y+1 );
    for x := x1-1 to x2-1 do
    begin
      if p^[i+1] <> oldCol then
      begin
        oldCol := p^[i+1] ;
        buf    := writeColour( oldCol and 15, oldCol shr 4 );
        fwrite( buf );
      end;
      fwritechar( char( p^[i] ) );
      inc(i , 2);
    end;
  end;
  freemem( p , (y2-y1+1)*(x2-x1+1) * 2 + 4 );
end;


procedure restore; assembler;
asm
  cmp word ptr messageBuf, 0
  jne @_data
  cmp word ptr messageBuf+2, 0
  jne @_data
  jmp @noData
@_data:
  push word ptr messageBuf+2
  push word ptr messageBuf
  call popscreen
  mov word ptr messageBuf, 0
  mov word ptr messageBuf+2, 0
@noData:
end;

function freadchar : word;
var
  fc : fchar;
begin
  asm
    mov  fc.w, 0
    mov  extChar,0
    xor  dh,dh
    mov  dl,fossilport

  @keyloop:
    cmp local, 0
    jne @local                          { Fossilport >128 z.B. 255 }

    mov  ah,03h
    int  14h                            { Status zurckliefern }
    test al,128
    jne  @local

    mov  modemhanged,1
    mov  hangCounter,1092
    jmp  @ende

  @local:
    cmp  timeout,0
    jne  @ende
    pusha
    call checkMessageStates
    popa

    mov  ah,1
    int  16h
    jnz  @sread

    cmp local, 0
    jne @keyLoop                        { Fossilport >128 z.B. 255 }

    xor  dh,dh
    mov  dl,fossilport
    mov  ah,0ch
    int  14h
    cmp  ax,-1
    jne  @cread
    jmp  @keyloop

  @sread:
    call restore
    mov  activity,_activity
    xor  ah, ah
    int  16h
    mov  fc.chr,al
    mov  fc.src,server
    or   al,al
    jne  @ende
    mov  extchar,ah
    jmp  @ende
  @cread:
    call restore
    mov  activity,_activity
    xor  dh,dh
    mov  dl,fossilport
    mov  ah,02h
    int  14h
    mov  fc.chr,al
    mov  fc.src,client
  @ende:
  end;
  freadchar:= fc.w;
end;

function freadkey : word;
label readCh;
var c : fchar;
begin
  c.w := 0;

  if extChar <> #0 then
  begin
       c.chr := extChar;
       c.src := server;
       freadkey := c.w;
       extChar := #0;
       exit;
  end;

 readCh:

  c.w := freadchar;

  if (c.src=server) or (modemhanged) or (timeout) then
  begin
       fReadkey := c.w;
       exit;
  end;

 { ab hier nur noch client mglich }
  case ansis of
  0: if c.chr = #27 then begin inc (ansis); goto readCh; end
     else if c.chr = #127 then
     begin
          c.chr := #0;  extChar := #83;
          fReadKey := c.w;
     end
     else fReadkey := c.w;
  1: if c.chr = '[' then begin inc (ansis); c.chr := #0; fReadkey := c.w; end
     else begin fReadkey := c.w; ansis := 0; end;
  2:
   begin
        case c.chr of
        #65 : c.chr := #72;
        #66 : c.chr := #80;
        #68 : c.chr := #75;
        #67 : c.chr := #77;
        #72 : c.chr := #71;
        #75 : c.chr := #79;
        end;
        fReadkey := c.w;
        ansis := 0;
   end;
  end;
end;

function fkeypressed : boolean;
var  value : boolean;
begin
     value := false;
     asm
        mov ah, 1
        int 16h
        jz @localEmpty
        mov value, 1
     @localEmpty:
        cmp local, 1
        je @serialEmpty
        xor dh, dh
        mov dl, fossilport
        mov ah, 3
        int 14h
        test al,128
        je  @hanged
        mov ah, 0ch
        int 14h
        cmp ax, -1
        je  @serialEmpty
        mov value, 1
        jmp @serialEmpty
      @hanged:
        mov modemhanged, 1
        mov hangCounter, 1092
      @serialEmpty:
     end;
     checkMessageStates;
     if not modemhanged then
       if keyPressed then fKeyPressed := true
       else fKeyPressed := value
     else fKeyPressed := false;
     if keyPressed then restore;
end;

procedure fwritechar (c:char); assembler;
asm
  cmp  timeout,0
  jne  @raus

  mov  al, c
  push ax
  call ansiWrite

  cmp local, 0
  jne @raus

  mov  al,c
  xor  dh,dh
  mov  dl,fossilport
  mov  ah,1
  int  14h
  test al,10000000b
  jne  @raus
  mov  modemhanged, 1
  mov  hangCounter, 1092
@raus:
end;

procedure fwrite ( s : string );
label raus;
var a : byte;
begin
  asm
    { lokale Ausgabe }
    lea  di, [s]
    mov  cl, ss:[di]
    inc  di
  @localOutput:
    mov  al, ss:[di]
    inc  di
    push di
    push cx
    push ax
    call ansiWrite
    pop  cx
    pop  di
    dec  cl
    jnz  @localOutput

    cmp local, 0
    jne raus

    { Schnittstellen-Ausgabe }
    push ss
    pop  es
    lea  di, [s]
    xor  ch, ch
    mov  cl, es:[di]
    inc  di
    xor  dh, dh
    mov  dl, fossilport
  @serialOutput:
    mov  ah, 19h
    int  14h
    add  di, ax
    sub  cx, ax

    mov  ah, 3
    int  14h
    test al,10000000b
    jne  @carrierOk
    mov  modemhanged, 1
    mov  hangCounter, 1092
    jmp  raus
  @carrierOk:
    cmp  timeout,0
    jne  raus                      { wenn TimeOut detect }

    or  cx, cx
    jnz @serialOutput
  end;

  raus:                                 { wenn Timeout... }
end;

procedure fwriteln (s:string);
var
  a : byte;
begin
  write( s + #10 + #13 );
end;

procedure fgotoxy (x,y:byte); assembler;
asm
  cmp  timeout,0
  jne  @raus

  mov  al, x
  push ax
  mov  al, y
  push ax
  call gotoxy

  cmp  local, 0
  jne  @raus

  mov  ah,01h
  mov  al,1bh   {ESC}
  xor  dx,dx
  mov  dl,fossilport
  int  14h

  mov  ax,015bh   {[}
  int  14h
  mov  al,x     { Binrzahl }
  xor  ah,ah    { my special Algo Hex2Dec }
  mov  bx,ax
  aaa
  xchg bx,ax
  and  al,0f0h
  aam
  add  ax,bx
  aaa
  mov  cx,ax
  mov  al,y     { Binrzahl }
  xor  ah,ah
  mov  bx,ax
  aaa
  xchg bx,ax
  and  al,0f0h
  aam
  add  ax,bx
  aaa           { in AX jetzt ungepackte BCD-Zahl (dezimal) }
  mov  bl,al
  mov  al,ah
  add  al,30h   { jetzt als ASCII-Zeichen }
  mov  ah,01h
  int  14h
  mov  al,bl
  add  al,30h   { jetzt als ASCII-Zeichen }
  mov  ah,01h
  int  14h
  mov  ax,013bh   {;}
  int  14h
  mov  al,ch
  add  al,30h   { jetzt als ASCII-Zeichen }
  mov  ah,01h
  int  14h
  mov  al,cl
  add  al,30h   { jetzt als ASCII-Zeichen }
  mov  ah,01h
  int  14h
  mov  ax,0148h   {H}
  int  14h
@raus:
end;

procedure ftextcolor(c:byte);
const
  ctab : array[0..7] of char = '04261537';
begin
  fwritechar(chr(27));
  fwritechar('[');
  if c > 7 then fwrite('1;') else fwrite ('0;');
  fwritechar('3');
  fwritechar(ctab[c and $7]);
  fwritechar('m');
end;

procedure ftextbackground(c:byte);
const
  ctab : array[0..7] of char = '04261537';
begin
  fwritechar(chr(27));
  fwritechar('[');
  fwritechar('4'); { Der dumme Ansi will Dezimalzahlen!!! -> sehr schwer mit str!!! }
  fwritechar(ctab[c and $7]);
  fwritechar('m');
end;

procedure setWatchDog ( on : boolean );
begin
     asm
        mov  al, on
        mov  ah, 14h
        mov  dl, fossilport
        xor  dh,dh
        int  14h
     end;
end;

procedure fossildone;
begin
  { ANSI.SYS baut sonst groe S...... ! }
  fgotoxy(1 , 7 );
  fwrite( writeColour(7, 0) );

  exitproc:=oldexitproc;
  setintvec($8,oldint8);
  asm
    xor  dx,dx
    mov  dl,fossilport
    mov  ah,05h
    xor  bx,bx
    int  14h
  end;
  if not debug then
  begin
    if not error then ExitInfo.userinfo.flags[4] := ExitInfo.userinfo.flags[4] and $7f; { 128 expl. lschen }
    seek(einfof,0);
    blockwrite(einfof, ExitInfo, sizeof(ExitInfo));
    close (einfof);
  end;
  halt;
end;

function pushScreen( x1 , y1 , x2 , y2 : byte) : bytePtr;
var i , x , y : word;
    p         : bytePtr;
begin
  pushScreen := nil;
  if y2 < y1 then exit; if x2 < x1 then exit;
  if memAvail < (y2-y1+1)*(x2-x1+1) * 2 + 4 then
  begin
    fbox('iCode DOORLIB '+ver , 'need more conventional ram!','ask your sysop to check thiz...');
    halt;
  end;
  getmem( p , (y2-y1+1)*(x2-x1+1) * 2 + 4 );

  p^[0]:=x1; p^[1]:=y1;
  p^[2]:=x2; p^[3]:=y2;
  i := 4;
  for y := y1-1 to y2-1 do
  begin
    for x := x1-1 to x2-1 do
    begin
      p^[i]   := mem[$b800:   y*160 + x shl 1];
      p^[i+1] := mem[$b800: 1+y*160 + x shl 1];
      inc(i, 2);
    end;
  end;
  pushScreen := p;
end;

{ hbyte : 1,2,3,4    hbit: 0,1,2,3,4,5,6,7 }
procedure hangup( hbyte , hbit : byte );
var
  a     : byte;
begin
  error := true;

  if (byte(hbyte-1) < 4) and (hbit < 8) then
    ExitInfo.userinfo.flags[hbyte]:=
    ExitInfo.userinfo.flags[hbyte] or (1 shl hbit);

  if timeout then
  begin
       textcolor(14);
       textbackground(4);
       gotoxy(30,10); write('[ iCode DOORLIB ]ͻ');
       gotoxy(30,11); write(' !!! TimeOut-Fehler !!! ');
       gotoxy(30,12); write('Ͷ');
       gotoxy(30,13); write('    Timeout-Zeitlimit   ');
       gotoxy(30,14); write('  wurde berschritten ! ');
       gotoxy(30,15); write('ͼ');
  end;
  if modemhanged then
  begin
       textcolor(11);
       textbackground(1);
       gotoxy(30,10); write('[ iCode DOORLIB ]ͻ');
       gotoxy(30,11); write(' !! CARRIER LOST !!! ');
       gotoxy(30,12); write('Ķ');
       gotoxy(30,13); write(' Verbindung zu Client');
       gotoxy(30,14); write('  ist abgebrochen !! ');
       gotoxy(30,15); write('ͼ');
  end;
  if timeover then
  begin
       textcolor(11);
       textbackground(1);
       gotoxy(30,10); write('[ iCode DOORLIB ]ͻ');
       gotoxy(30,11); write(' DAILY TIME LIMIT !! ');
       gotoxy(30,12); write('Ķ');
       gotoxy(30,13); write(' Das tgliche Zeit-  ');
       gotoxy(30,14); write(' limit ist abgelaufen');
       gotoxy(30,15); write('ͼ');
  end;
  for a:=1 to 10 do
    begin
         sound(440);
         delay(50);
         sound(550);
         delay(40);
         sound(660);
         delay(30);
    end;
  nosound;
  delay(1000);
end;

procedure int8handler; interrupt; assembler;
asm
  { ist carrier schon weg? }
  cmp  modemhanged, 0
  je   @notHanged
  { jup. ist die minute schonfrist schon um? }
  mov  ax, hangCounter
  dec  ax
  jnz  @label1
  { jup. programm zwangsbeenden }
  mov  carrier.kill, 1
@label1:
  { nope. }
  mov hangCounter, ax
@notHanged:

  { ist 5-minuten-frist abgelaufen ? }
  mov  ax,activity
  dec  ax
  jnz  @weiter
  { jup. das Master-Programm hat die Gelegenheit verpasst, selbst zu beenden }
  { zwangsbeendung... }
  mov inactivity.kill, 1
@weiter:
  { nope }
  { ist 4 Minuten-Frist abgelaufen ? }
  cmp  ax,1092
  jne   @ok
  { jup. Flag setzen, Master-Programm sollte innerhalb einer Minute beenden }
  mov  timeout,1
@ok:
  { nope }
  { ist 3 Minuten-Frist abgelaufen ? }
  cmp  ax, 2184
  jne  @noMessage
  { jup. Flag setzen, um Message ausgeben }
  mov inactivity.showMessage, 1
@noMessage:
  { nope }
  mov  activity,ax

  { Tgliches Zeitlimit... }
  mov ax, resttime
  mov dx, resttime18
  { evtl noch 2 Minuten? -> Message anzeigen... }
  cmp ax, 1
  ja @lb1
  cmp daily.messagedone, 1
  je @lb1
  mov daily.messagedone, 1
  mov daily.showmessage, 1
@lb1:
  { evtl noch 1 Minute? -> Flag fr Master-Programm setzen... }
  or  ax, ax
  jnz @lb3
  mov timeOver, 1
@lb2:
  { evtl Zeit ganz vorbei? -> Terminierung! }
  or dx, dx
  jnz @lb3
  mov daily.kill, 1
@lb3:
  { Zeit erniedrigen... }
  dec dx
  jns @lb4
  mov dx, 1091
  dec ax
@lb4:
  mov resttime18, dx
  mov resttime, ax

  pushf
  call [oldint8]
end;


function freset ( fileName : string ; var fileHandle : file ) : boolean;
{
   Syntax:     fReset(filename , fileHandle) : errorLevel;
   SyntaxBsp:  errorLevel := fReset(config.ra , configHandle);
   ShortDocu:  fReset such nach der im String bergebenen Datei zuerst im
                Node-Verzeichnis und anschlieend im RA-Verzeichnis. Sinnvoll
                ist diese Vorgehensweise z.B. bei MODEM.RA, CONFIG.RA etc...
                Wird das File gefunden, dann wird das handle in fileHandle
                zurckgegeben und freset auf TRUE gesetzt.
   Coder:      Falcon - 20.11.1996
}
var io     : byte;
begin
  {$i-}
  assign( fileHandle , nodeDir + filename );
  reset( fileHandle , 1 );
  io := ioResult;
  if io <> 0 then fReset := false else
  begin
    fReset := true;
    exit;
  end;

  assign( fileHandle , raDir + filename );
  reset( fileHandle , 1 );
  io := ioResult;
  if io = 0 then fReset := true else fReset := false;
end;

Procedure cursorOff;
var   buf : string;
      c   : byte;
      i   : word;
      x,y : byte;
begin;
  asm
  { 1 - Ein Leerzeichen suchen }
    push ds
    mov  ax, 0b800h
    mov  ds, ax
    mov  cx, 2000
    xor  si, si
    mov  ax, 2
  @Loop:
    cmp  byte ptr [si], 32
    je   @foundSpace
    add  si, ax
    dec  cx
    jns  @Loop
    xor  si, si
  @foundSpace:
    pop ds
    mov i, si
  { 2 - zugehrige X- und Y-Koordinaten berechnen }
    mov ax, si
    mov cl, 160
    div cl
    shr ah, 1
    add ax, 101h
    mov  x, ah
    mov  y, al
  end;
  { Den Farbcode im oberen linken Eck des Bildschirms in ANSI konvertieren }
  buf := WriteColour ( mem[$b800:i+1] shr 4 , mem[$b800:i+1] shr 4 );
  { den ASCII-Wert dazukopieren }
  buf := buf + ' ';
  fgotoxy( x , y );
  fwrite( buf );
  fgotoxy( x , y );
end;

function writeColour(c, b : byte):string;
const colour : array [0..7] of string[2] = ('30','34','32','36','31','35','33','37');
      back   : array [0..7] of string[2] = ('40','44','42','46','41','45','43','47');
var trash : string;
begin
  trash:='[';

  if c > 7 then trash:=trash+'1;' else trash:=trash+'0;';
  if c > 7 then dec(c, 8);
  trash:=trash + colour[c] + ';';

  if b > 7 then dec(b, 8);
  trash:=trash + back[b] + 'm';
  writeColour:=trash;
end;

procedure fBox ( s1 , s2 , s3 : string);
var i : byte;
procedure xdraw(a:string);
var ablage : string;
    i      : byte;
    light  : byte;
    c      : char;
begin
  fwrite( writeColour( 5 , 0 ) );
  fillchar( ablage , 81 , 250 ); ablage[0]:=char(80);
  for i := 1 to byte(a[0]) do ablage[40-(byte(a[0])div 2)+i] := a[i];
  light := 0;
  for i := 1 to 80 do begin
    c := ablage[i];
    if (byte(c)<byte('0')) or (byte(c)>byte('z')) then
    begin
      light := 5;
    end;
    if light = 4 then fwrite( writeColour( 15 , 0 ) );
    if (light = 3) or (light = 2) then fwrite( writeColour( 13 , 0 ) );
    if light = 1 then fwrite( writeColour(  5 , 0 ) );
    if light > 0 then dec( light );
    if c=' ' then c :='';
    fWriteChar(c);
  end;
end;

begin
  { Bildschirm lschen , Standardfarben }
  fgotoxy( 1 , 1 );  fwrite( writeColour(7, 0) );  fwrite( #27+'[2J' );

  fgotoxy( 1 , 1 );
  fWrite( writeColour( 5 , 0 ) );
  for i := 1 to 80 do fWriteChar('');

  { Erste Zeile ausgeben }
  fgotoxy(1 , 2);
  xdraw( s1 );

  { Zweite Zeile ausgeben }
  fgotoxy(1 , 3);
  fwrite( writeColour(15, 4) );
  xdraw( s2 );

  { Dritte Zeile ausgeben }
  fgotoxy(1 , 4);
  fwrite( writeColour(15, 4) );
  xdraw( s3 );

  for i := 1 to 80 do fWriteChar('');
  cursorOff;
end;

procedure initdebug;
begin
    if debug then
    begin
      exitInfo.baud := 0;
      exitInfo.sysinfo.TotalCalls := 0;
      exitInfo.sysinfo.LastCaller := 'iCode DOORLIB';
      exitInfo.userInfo.name := 'SYSOP';
      exitInfo.userInfo.security := 65535;
    end;
end;

procedure checkFossil;
const fossilInst : boolean = false;         { gesetzt, wenn Fossil installiert }
begin
  { fALCON: Auf installierten Fossil-Treiber checken... }
  asm
    push 0
    pop  es
    mov  di, word ptr es:[14h*4]
    mov  es, word ptr es:[14h*4+2]
    add  di, 6
    cmp  word ptr es:[di], 1954h
    jne @noFossil
    mov fossilInst , 1
   @noFossil:
  end;
  if not fossilInst then
  begin
    local := true;
    fBox('iCode DoorLib '+ver,'no fossil driver found','local-mode started');
    delay(1000);
  end;


end;

procedure readModem;
var
  mr  :  modemRecord;
  f   :  file;
begin
     if not fReset ( 'MODEM.RA' , f ) then
     begin
          fBox( 'iCode doorLib '+ver , 'File MODEM.RA Was Not Found' , 'ask SYSOP to check paths!' );
          delay(1000);
          halt;
     end;
     blockread( f , mR , sizeOf( mR ) ); { Modem-Konfiguration }
     fossilPort := mr.comPort ;
     dec ( fossilPort );
     close( f );
end;

procedure readLimits;
const
  done :  boolean = false;
var
  lr   :  limitsRecord;
  f    :  file;
begin
     if not fReset ( 'LIMITS.RA' , f ) then
     begin
          fBox( 'iCode doorLib '+ver , 'File LIMITS.RA Was Not Found' , 'ask SYSOP to check paths!' );
          delay(1000);
          halt;
     end;
     dailyTime := 0;
     repeat
           {$i-}
           blockread( f , lR , sizeOf( lR ) ); { Modem-Konfiguration }
           if ioresult <> 0 then done := true
           {$i+}
           else begin
                if lr.security = exitinfo.userinfo.security then
                begin
                     dailyTime := lr.ltime;
                     done := true;
                end;
           end;
     until done;
     if dailyTime > exitinfo.userinfo.elapsed
        then restTime := dailyTime - exitinfo.userinfo.elapsed
        else restTime := 0;
     close( f );
end;

procedure initDoorLib(nodePath : string);
begin
  { fALCON: Verzeichnisse ermitteln }
  if nodePath='' then getDir(0, nodeDir) else nodeDir:=nodePath;
  if nodeDir[byte(nodeDir[0])]<>'\' then nodeDir:=nodeDir+'\';
  raDir := getenv('RA');
  if raDir[byte(raDir[0])]<>'\' then raDir:=raDir+'\';

  checkFossil;

  { EXITINFO.BBS einlesen. Aktuelles Verzeichnis, oder Node-Verzeichnis }
  if not freset( 'EXITINFO.BBS' , einfof ) then
  begin { keine EXITINFO gefunden }
       debug := true;
       local := true;
       fossilport:=255;
       fBox('iCode DoorLib '+ver,'EXITINFO.BBS Not Found','debug-mode started');
       initdebug;
       delay(1000);
  end else
  begin { EXITINFO gefunden }
    debug := false;
    blockread (einfof, ExitInfo, sizeOf (ExitInfo));
    if exitInfo.baud = 0 then
    begin
         local := true;
         fossilport:=255;
         initdebug;
    end else
    begin
      local := false;
      readModem;
    end;
  end;

  readLimits;

  asm { fossil - port - init  0 }
    xor  dh,dh
    mov  dl,fossilport
    mov  ah,04h
    xor  bx,bx
    int  14h
  end;


  activity := _activity;
  { Timer-Interrupt 8 auf eigene Proc verbiegen. }
  getintvec($8,oldint8);
  setintvec($8,@int8handler);
  { Eigene Exit-Proc installieren }
  oldexitproc:=exitproc;
  exitproc:=@fossildone;

  ansis := 0;
end;

end.
